// C Header File
// Created 19/02/2003; 01:47:02

#ifdef DOORS
#ifndef __H_polysnd
#define __H_polysnd						//1.02

#define PlayStereoSound(Channel1,Channel2,Tempo) \
  ({ asm ("move.l %0,%%a1" :: "g"(Channel1)); \
     asm ("move.l %0,%%a2" :: "g"(Channel2)); \
     asm ("move.w #0,%d0"); \
     asm ("move.w #0,%d1"); \
     asm ("move.w %0,%%d2" :: "g"(Tempo)); \
     asm ("jsr polysnd__0000"); })

/*;-------------------------------------------------------------
;    PolySnd: Fonctions sonores
;		par Geoffrey ANNEHEIM
;	Grand Merci  Laurent PONCEY pour son programme Sound6d	
;-------------------------------------------------------------

PolySnd::PlayStereoSound		equ	polysnd@0000
;--------------------------------------------------------------
;PlayStereoSound(Table des frquences,Morceau 1,Morceau 2,Tps1,Tps2,UnitTps)
;
;   Joue une musique au format stro soit Morceau 1 correspond  l'couteur
;   gauche et morceau 2  l'couteur droit.
;   La table des frquences correspond au frquence de chaque notes de musique.
;   Tps1 dure ajoute  la dure de la note en cours du morceau 1.
;   Tps2 dure ajoute  la dure de la note en cours du morceau 2.
;   UnitTps rptiton (Tempo)
;   TI-92=0h5000.
;
;Input:	a1.l = Morceau 1 soit couteur Gauche		lea	morc1(PC),a1
;	a2.l = Morceau 2 soit couteur Droit		lea	morc2(PC),a2
;	d0.w = tps1 en Hexadcimal			move.w	#$0,d0
;	d1.w = tps2 en Hexadcimal			move.w	#$0,d1		
;	d2.w = unittps en Hexadcimal			move.w	#$5000,d2	move.w Tempo_120,d2
;
;Output: nothing
;	ALL REGISTERS DESTROYED
;--------------------------------------------------------------*/

//#=D

/*;******************************************************
;Enumration des notes par octaves  la norme Franaise
;*******************************************************/

/*;------------
;| OCTAVE 0 |
;------------*/

#define	do_0		0x8c
#define doD_0		0x8b
#define reb_0		0x8b
#define re_0		0x8a
#define reD_0		0x89
#define mib_0		0x89
#define mi_0		0x88
#define fa_0		0x87
#define faD_0		0x86
#define solb_0	0x86
#define sol_0		0x85
#define solD_0	0x84
#define lab_0		0x84
#define la_0		0x83
#define laD_0		0x82
#define sib_0		0x82
#define si_0		0x81

 
/*;------------
;| OCTAVE 1 |
;------------*/

#define do_1		0x7c
#define doD_1		0x7b
#define reb_1		0x7b
#define re_1		0x7a
#define reD_1		0x79
#define mib_1		0x79
#define mi_1		0x78
#define fa_1		0x77
#define faD_1		0x76
#define solb_1	0x76
#define sol_1		0x75
#define solD_1	0x74
#define lab_1		0x74
#define la_1		0x73
#define laD_1		0x72
#define sib_1		0x72
#define si_1		0x71


/*;------------
;| OCTAVE 2 |
;------------*/

#define do_2		0x6c
#define doD_2		0x6b
#define reb_2		0x6b
#define re_2		0x6a
#define reD_2		0x69
#define mib_2		0x69
#define mi_2		0x68
#define fa_2		0x67
#define faD_2		0x66
#define solb_2	0x66
#define sol_2		0x65
#define solD_2	0x64
#define lab_2		0x64
#define la_2		0x63
#define laD_2		0x62
#define sib_2		0x62
#define si_2		0x61


/*;------------
;| OCTAVE 3 |
;------------*/

#define do_3		0x5c
#define doD_3		0x5b
#define reb_3		0x5b
#define re_3		0x5a
#define reD_3		0x59
#define mib_3		0x59
#define mi_3		0x58
#define fa_3		0x57
#define faD_3		0x56
#define solb_3	0x56
#define sol_3		0x55
#define solD_3	0x54
#define lab_3		0x54
#define la_3		0x53
#define laD_3		0x52
#define sib_3		0x52
#define si_3		0x51


/*;------------
;| OCTAVE 4 |
;------------*/

#define do_4		0x4c
#define doD_4		0x4b
#define reb_4		0x4b
#define re_4		0x4a
#define reD_4		0x49
#define mib_4		0x49
#define mi_4		0x48
#define fa_4		0x47
#define faD_4		0x46
#define solb_4	0x46
#define sol_4		0x45
#define solD_4	0x44
#define lab_4		0x44
#define la_4		0x43
#define laD_4		0x42
#define sib_4		0x42
#define si_4		0x41


/*;------------
;| OCTAVE 5 |
;------------*/

#define do_5		0x3c
#define doD_5		0x3b
#define reb_5		0x3b
#define re_5		0x3a
#define reD_5		0x39
#define mib_5		0x39
#define mi_5		0x38
#define fa_5		0x37
#define faD_5		0x36
#define solb_5	0x36
#define sol_5		0x35
#define solD_5	0x34
#define lab_5		0x34
#define la_5		0x33
#define laD_5		0x32
#define sib_5		0x32
#define si_5		0x31


/*;------------
;| OCTAVE 6|
;------------*/

#define do_6		0x2c
#define doD_6		0x2b
#define reb_6		0x2b
#define re_6		0x2a
#define reD_6		0x29
#define mib_6		0x29
#define mi_6		0x28
#define fa_6		0x27
#define faD_6		0x26
#define solb_6	0x26
#define sol_6		0x25
#define solD_6	0x24
#define lab_6		0x24
#define la_6		0x23
#define laD_6		0x22
#define sib_6		0x22
#define si_6		0x21


/*;------------
;| OCTAVE 7 |
;------------*/

#define do_7		0x1c
#define doD_7		0x1b
#define reb_7		0x1b
#define re_7		0x1a
#define reD_7		0x19
#define mib_7		0x19
#define mi_7		0x18
#define fa_7		0x17
#define faD_7		0x16
#define solb_7	0x16
#define sol_7		0x15
#define solD_7	0x14
#define lab_7		0x14
#define la_7		0x13
#define laD_7		0x12
#define sib_7		0x12
#define si_7		0x11


/*;*******************************************************
;Enumration des notes par octaves sous forme de lettres
;********************************************************/

/*;------------
;| OCTAVE 0 |
;------------*/

#define C_0			0x8c
#define CD_0		0x8b
#define Db_0		0x8b
#define D_0			0x8a
#define DD_0		0x89
#define Eb_0		0x89
#define E_0			0x88
#define F_0			0x87
#define FD_0		0x86
#define Gb_0		0x86
#define G_0			0x85
#define GD_0		0x84
#define Ab_0		0x84
#define A_0			0x83
#define AD_0		0x82
#define Bb_0		0x82
#define B_0			0x81 
 
/*;------------
;| OCTAVE 1 |
;------------*/

#define C_1			0x7c
#define CD_1		0x7b
#define Db_1		0x7b
#define D_1			0x7a
#define DD_1		0x79
#define Eb_1		0x79
#define E_1			0x78
#define F_1			0x77
#define FD_1		0x76
#define Gb_1		0x76
#define G_1			0x75
#define GD_1		0x74
#define Ab_1		0x74
#define A_1			0x73
#define AD_1		0x72
#define Bb_1		0x72
#define B_1			0x71


/*;------------
;| OCTAVE 2 |
;------------*/

#define C_2			0x6c
#define CD_2		0x6b
#define Db_2		0x6b
#define D_2			0x6a
#define DD_2		0x69
#define Eb_2		0x69
#define E_2			0x68
#define F_2			0x67
#define FD_2		0x66
#define Gb_2		0x66
#define G_2			0x65
#define GD_2		0x64
#define Ab_2		0x64
#define A_2			0x63
#define AD_2		0x62
#define Bb_2		0x62
#define B_2			0x61


/*;------------
;| OCTAVE 3|
;------------*/

#define C_3			0x5c
#define CD_3		0x5b
#define Cb_3		0x5b
#define D_3			0x5a
#define DD_3		0x59
#define Eb_3		0x59
#define E_3			0x58
#define F_3			0x57
#define FD_3		0x56
#define Gb_3		0x56
#define G_3			0x55
#define GD_3		0x54
#define Ab_3		0x54
#define A_3			0x53
#define AD_3		0x52
#define Bb_3		0x52
#define B_3			0x51


/*;------------
;| OCTAVE 4 |
;------------*/

#define C_4			0x4c
#define CD_4		0x4b
#define Db_4		0x4b
#define D_4			0x4a
#define DD_4		0x49
#define Eb_4		0x49
#define E_4			0x48
#define F_4			0x47
#define FD_4		0x46
#define Gb_4		0x46
#define G_4			0x45
#define GD_4		0x44
#define Ab_4		0x44
#define A_4			0x43
#define AD_4		0x42
#define Bb_4		0x42
#define B_4			0x41

/*;------------
;| OCTAVE 5 |
;------------*/

#define C_5			0x3c
#define CD_5		0x3b
#define Db_5		0x3b
#define D_5			0x3a
#define DD_5		0x39
#define Eb_5		0x39
#define E_5			0x38
#define F_5			0x37
#define FD_5		0x36
#define Gb_5		0x36
#define G_5			0x35
#define GD_5		0x34
#define Ab_5		0x34
#define A_5			0x33
#define AD_5		0x32
#define Bb_5		0x32
#define B_5			0x31

/*;------------
;| OCTAVE 6 |
;------------*/

#define C_6			0x2c
#define CD_6		0x2b
#define Db_6		0x2b
#define D_6			0x2a
#define DD_6		0x29
#define Eb_6		0x29
#define E_6			0x28
#define F_6			0x27
#define FD_6		0x26
#define Gb_6		0x26
#define G_6			0x25
#define GD_6		0x24
#define Ab_6		0x24
#define A_6			0x23
#define AD_6		0x22
#define Bb_6		0x22
#define B_6			0x21


/*;------------
;| OCTAVE 7 |
;------------*/

#define C_7			0x1c
#define CD_7		0x1b
#define Db_7		0x1b
#define D_7			0x1a
#define DD_7		0x19
#define Eb_7		0x19
#define E_7			0x18
#define F_7			0x17
#define FD_7		0x16
#define Gb_7		0x16
#define G_7			0x15
#define GD_7		0x14
#define Ab_7		0x14
#define A_7			0x13
#define AD_7		0x12
#define Bb_7		0x12
#define B_7			0x11


/*;***********************************************************
;Enumration des notes par octaves sous forme de lettres n2
;************************************************************/

/*;------------
;| OCTAVE 0 |
;------------*/

#define _c0			0x8c
#define _cs0		0x8b
#define _db0		0x8b
#define _d0			0x8a
#define _ds0		0x89
#define _eb0		0x89
#define _e0			0x88
#define _f0			0x87
#define _fs0		0x86
#define _gb0		0x86
#define _g0			0x85
#define _gs0		0x84
#define _ab0		0x84
#define _a0			0x83
#define _as0		0x82
#define _bb0		0x82
#define _b0			0x81
 
/*;------------
;| OCTAVE 1 |
;------------*/

#define _c1			0x7c
#define _cs1		0x7b
#define _db1		0x7b
#define _d1			0x7a
#define _ds1		0x79
#define _eb1		0x79
#define _e1			0x78
#define _f1			0x77
#define _fs1		0x76
#define _gb1		0x76
#define _g1			0x75
#define _gs1		0x74
#define _ab1		0x74
#define _a1			0x73
#define _as1		0x72
#define _bb1		0x72
#define _b1			0x71


/*;------------
;| OCTAVE 2 |
;------------*/

#define _c2			0x6c
#define _cs2		0x6b
#define _db2		0x6b
#define _d2			0x6a
#define _ds2		0x69
#define _eb2		0x69
#define _e2			0x68
#define _f2			0x67
#define _fs2		0x66
#define _gb2		0x66
#define _g2			0x65
#define _gs2		0x64
#define _ab2		0x64
#define _a2			0x63
#define _as2		0x62
#define _bb2		0x62
#define _b2			0x61


/*;------------
;| OCTAVE 3 |
;------------*/

#define _c3			0x5c
#define _cs3		0x5b
#define _cb3		0x5b
#define _d3			0x5a
#define _ds3		0x59
#define _eb3		0x59
#define _e3			0x58
#define _f3			0x57
#define _fs3		0x56
#define _gb3		0x56
#define _g3			0x55
#define _gs3		0x54
#define _ab3		0x54
#define _a3			0x53
#define _as3		0x52
#define _bb3		0x52
#define _b3			0x51


/*;------------
;| OCTAVE 4 |
;------------*/

#define _c4			0x4c
#define _cs4		0x4b
#define _db4		0x4b
#define _d4			0x4a
#define _ds4		0x49
#define _eb4		0x49
#define _e4			0x48
#define _f4			0x47
#define _fs4		0x46
#define _gb4		0x46
#define _g4			0x45
#define _gs4		0x44
#define _ab4		0x44
#define _a4			0x43
#define _as4		0x42
#define _bb4		0x42
#define _b4			0x41


/*;------------
;| OCTAVE 5 |
;------------*/

#define _c5			0x3c
#define _cs5		0x3b
#define _db5		0x3b
#define _d5			0x3a
#define _ds5		0x39
#define _eb5		0x39
#define _e5			0x38
#define _f5			0x37
#define _fs5		0x36
#define _gb5		0x36
#define _g5			0x35
#define _gs5		0x34
#define _ab5		0x34
#define _a5			0x33
#define _as5		0x32
#define _bb5		0x32
#define _b5			0x31


/*;------------
;| OCTAVE 6 |
;------------*/

#define _c6			0x2c
#define _cs6		0x2b
#define _db6		0x2b
#define _d6			0x2a
#define _ds6		0x29
#define _eb6		0x29
#define _e6			0x28
#define _f6			0x27
#define _fs6		0x26
#define _gb6		0x26
#define _g6			0x25
#define _gs6		0x24
#define _ab6		0x24
#define _a6			0x23
#define _as6		0x22
#define _bb6		0x22
#define _b6			0x21


/*;------------
;| OCTAVE 7 |
;------------*/

#define _c7			0x1c
#define _cs7		0x1b
#define _db7		0x1b
#define _d7			0x1a
#define _ds7		0x19
#define _eb7		0x19
#define _e7			0x18
#define _f7			0x17
#define _fs7		0x16
#define _gb7		0x16
#define _g7			0x15
#define _gs7		0x14
#define _ab7		0x14
#define _a7			0x13
#define _as7		0x12
#define _bb7		0x12
#define _b7			0x11

#define pause		0x00	//;pause est pris en compte comme une note.
#define rest		0x00

/*;*****************************************************************************
;La plupart des morceaux de musique utilisent les tempos suivant. Mais si vous
;voulez crer un tempo ne figurant pas dans la liste voici la procdure:
;
;120/par votre tempo=indice
;valeur du tempo 120 (7376)*indice=valeur du tempo en dcimal.
;Il ne vous reste qu' convertir la valeur dcimal en hexadcimal grce  la
;calculatrice fournie par windows.
;
;exemple:
;********
;
;votre tempo=94
;120/94=1.2766
;7376*1.2766=9416
;9416=24C8 en hexadcimal
;
;
;Instruction:
;------------
;
;move.w	#9416,d2 ou move.w #$24C8,d2
;
;
;Attention si votre nombre hexadcimal est infrieur  1000 (4096) ou est
;suprieur  FFFF (65535), le programme ne fonctionnera pas correctement.
;******************************************************************************/

#define Tempo_220		0x0FB8	//;soit 4023
#define Tempo_180		0x1335	//;soit 4917
#define Tempo_152		0x16BF	//;soit 5823
#define Tempo_140		0x18B2	//;soit 6322
#define Tempo_136		0x196C	//;soit 6508
#define Tempo_120		0x1CD0	//;soit 7376
#define Tempo_116		0x1DCE	//;soit 7630
#define Tempo_112		0x1EDF	//;soit 7903
#define Tempo_104		0x213F	//;soit 8511
#define Tempo_96		0x2404	//;soit 9220
#define Tempo_92		0x2595	//;soit 9621
#define Tempo_88		0x274A	//;soit 10058
#define Tempo_80		0x2B38	//;soit 11064
#define Tempo_72		0x3005	//;soit 12293

/*;*****************************************************************************
;Voici la liste des dure. Cette liste peut tre modifi.
;Par dfaut 30=noir.
;Dures talonnes avec prcision en fonction du tempo.
;
;Ronde = 4 temps
;Blanche = 2 temps
;Blanche pointe = 2+1/2
;Noir pointe = 1+1/2 temps
;Noir = 1 temps
;Croche pointe = 1/2+1/4 temps
;Croche = 1/2 temps
;Double croche = 1/4 temps
;Triple croche = 1/8 temps
;Triolet = 1/3 temps
;******************************************************************************/

#define _r			120
#define _bp			75
#define _b			60
#define _np			45	
#define _n			30
#define _cp			22
#define _c			15
#define _cc			7
#define _ccc			4
#define _cccc		2
#define _tri			10

#define ronde			120
#define blanche_pointee		75
#define blanche			60
#define noir_pointee		45	
#define noir			30
#define croche_pointee	22
#define croche			15
#define double_croche		7
#define triple_croche		4
#define quadruple_croche 	2

#define _soupir			30
#define _soupirp		45
#define soupir			30
#define soupir_pointe		45

#define whole			120	//;Ronde
#define half			60	//;Blanche
#define quarter			30	//;Noir
#define eighth			15	//;Croche
#define sixteenth		7	//;Double croche
#define thirtysecond		4	//;Triple croche
#define sixtyfourth 	2	//;Quadruple croche

#define half3			20
#define quarter3		10
#define eighth3			5
#define sixteenth3		2
#define thirtysecond3		1
#define sixtyfourth3		0

#endif
#else
#error: Vous devez tre en mode KERNEL pour pouvoir utiliser la librairies PolySnd
#endif


