	;include "tios.h"
	include "doorsos.h"
	
	xdef _library
	xdef _ti89
	xdef _ti92plus
	xdef polysnd@0000

polysnd@0000:

;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Joue le morceau 1 sur l'couteur gauche
;Joue le morceau 2 sur l'couteur droit
;
;a1=Morceau 1 soit couteur Gauche		lea	morc1(PC),a1
;a2=Morceau 2 soit couteur Droit		lea	morc2(PC),a2
;d0=tps1					move.w	#$0,d0
;d1=tps2					move.w	#$0,d1
;d2=unittps					move.w	#$6000,d2
;-----------------------------------------------------------------------------
;*****************************************************************************
;Les niveaux de gris de fonctionnerons pas car l'interruption de l'horloge n1
;du processeur est dsactive pour pouvoir jouer la musiques sur les 2 canaux.
;*****************************************************************************

PlayStereoSound:
	move.b	CALCULATOR,calc			;Dtecte la calculatrice 0 TI-89, 1 TI-92 Plus
	move.w	d0,tps1
	move.w	d1,tps2
	move.w	d2,unittps			;Tempo
	clr.l	d0
	
	;move.w	#$700,d0			;Dplace le chiffre 1792 pour
	;trap	#1				;dsactiver l'auto-interruption n1
	;move.w	d0,-(sp)			;Enregistre l'handle de int1 dans d0
	
	lea	TblFreq(PC),a0			;Charge la liste des frquences dans a0
	;lea 	morc1(PC),a1			;Charge les donnes du morceau 1 dans a1
	;lea	morc2(PC),a2			;Charge les donnes du morceau 2 dans a2
	
	bset	#6,($60000C)			;Initialise le port IO soit le byte 6 mie  1
	bclr	#0,($60000E)			;Initialise l'couteur gauche
	bclr	#1,($60000E)			;Initialise l'couteur droit
	
	move.b	#1,duree1			;Initialize duree1  1
	move.b	#1,duree2		 	;Initialize duree2  2
	
boucle:
	sub.b	#1,duree1			;soutrait 1  duree1
	cmp.b	#0,duree1			;Si duree1!=0 alors
	bne	cont_1				;aller  cont_1
	
;charge1
;touche [ESC] enfonc ?
	cmp	#0,calc				;Si TI-89
	beq	key_89				;Aller  key_89
	bne	key_92				;sinon key_92

key_89: move.w	#6,d0				;Sur TI-89, detection touche [ESC]
	bsr	masque				;Clavier en bas niveau
	btst.b	#0,d0
	beq	fin
	bne	suite

key_92:	move.w	#8,d0				;dplace 8 dans d0
	bsr	masque				;Va  masque pour lire en bas niveau le clavier
	btst.b	#6,d0				;Teste le bit 6 du clavier
	beq	fin				;Si le bit 6 est  1 soit touche ESC press alors aller  fin
	
suite:	cmp.b	#255,(a1)			;Vrifie si dans le morceau en cours si il y a 255 soit 0hFF 
	beq	fin				;255=end;alors aller  fin
	clr.l	d0				;Efface le registre d0
	;clr.b	d2
	
	move.b	(a1)+,d0			;frquence dans d0
	move.b	(a1)+,d2			;longueur dans d2
	move.b	#1,d1				;Dplace 1 dans d1 (d1 tmoin  1)
	bsr	decode				;Va au dcodage des notes
	move.w	tps1,d7				;dure crneau 1
;en opposition de polarit avec 2

	btst	#1,($60000E)			;Vrifie si le bit 1 est  1
	bne	plus1				;Si 1 alors aller  plus1
	bclr	#0,($60000E)			;Initialize couteur gauche
	bra	cont_1				;Va  cont_1

plus1:
	bset	#0,($60000E)			;Met  1 le bit 0 de l'couteur gauche

cont_1:
	sub.b	#1,duree2			;Soustrait de 1 duree2
	cmp.b	#0,duree2			;Si duree2!=0
	bne	cont_2				;alors aller  cont_2
;charge2
	cmp.b	#255,(a2)			;De mme pour morceau 2
	beq	fin			;255=fin
	clr.l	d0
	;clr.b	d2
	
	move.b	(a2)+,d0		;frquence
	move.b	(a2)+,d2		;longueur
	move.b	#2,d1
	bsr	decode
	move.w	tps2,d6
;en opposition de polarit avec 1
	btst	#0,($60000E)
	bne	plus2
	bclr	#1,($60000E)
	bra	cont_2

plus2:
	bset	#1,($60000E)
	
cont_2:
	move.w	unittps,d4
	
;cas d'une pause
	cmp.w	tps1,d4
	bhi	paspause1
	move.w	tps1,d7

paspause1:
	cmp.w	tps2,d4
	bhi	paspause2
	move.w	tps2,d6

paspause2:
	
;joue le son pendant une dure lmentaire
bcle_son:
	dbra.w	d7,son_1
	move.w	tps1,d7
	bchg	#0,($60000E)
	
son_1:
	dbra.w	d6,son_2
	move.w	tps2,d6
	bchg	#1,($60000E)

son_2:
	dbra	d4,bcle_son
	bra	boucle
	

fin:
	bclr	#0,($60000E)
	bclr	#1,($60000E)
	move.b	#$8D,($60000C)
	
	;move.w	(sp)+,d0
	;trap	#1
	rts
	
;******************************************************************
;Decode une valeur de note
;------------------------------------------------------------------
;d0=valeur code (1er chiffre hexa=octave,2me=note)
;d1=voie (1 ou 2)
;d2=dure
; =>d0=frquence
;******************************************************************

decode:
	move.l	d1,-(a7)
	cmp.w	#0,d0
	beq	pause
	
	move.l	d0,d1
	ror.l	#4,d1
	
	sub.w	#1,d1
	mulu.w	#12,d1
	and.w	#$0f,d0
	sub.w	#1,d0
	add.w	d1,d0
	
	rol.l	#1,d0
	move.l	a0,a3
	
	add.w	d0,a3
	clr.l	d0
	move.w	(a3),d0
	bra	stoc

pause:
	move.w	unittps,d0
	add.w	#1,d0

stoc:
	move.l	(a7)+,d1
	cmp.b	#1,d1
	bne 	stoc2
	move.w	d0,tps1
	move.b	d2,duree1
	
	;;-----------------------
	;;Affiche frquence voie1
	;;-----------------------
	;move.w	d0,d5
	;move.l	#2,d1
	;move.l	#1,d2
	;move.l	#3,d4
	;jsr	hexlib::put_hex
	;move.w	d5,d0
	
	
	;;-------------------
	;;Affiche dure voie1
	;;-------------------
	;move.b	duree1,d0
	;move.l	#4,d1
	;move.l	#1,d2
	;move.l	#3,d4
	;jsr	hexlib::put_hex

	rts

stoc2:
	move.w	d0,tps2
	move.b	d2,duree2
	
	;;-----------------------
	;;Affiche frquence voie2
	;;-----------------------
	;move.w	d0,d5
	;move.l	#3,d1
	;move.l	#1,d2
	;move.l	#3,d4
	;jsr	hexlib::put_hex
	;move.w	d5,d0
	
	
	;;-------------------
	;;Affiche dure voie2
	;;--------------------
	;move.b	duree2,d0
	;move.l	#5,d1
	;move.l	#1,d2
	;move.l	#3,d4
	;jsr	hexlib::put_hex
	rts

;********************************************
;masque une ligne du clavier
;--------------------------------------------
;d0=ligne -> d0=rponse
;********************************************
masque:
	movem.l	d1,-(a7)
	move.w	#$FFFE,d1
	rol.w	d0,d1
	clr.w	d0
	move.w	d1,($600018)
	nop
	nop
	nop
	nop
	nop
	nop
	move.b	($60001B),d0
	movem.l	(a7)+,d1
	RTS
	
;----------------------------------------------------------------------------
;Donnes pour la libraire PolySnd
;----------------------------------------------------------------------------
	
TblFreq: dc.w	$011,$012,$013,$014,$015,$016,$017,$019,$01a,$01c,$01d,$01f
	 dc.w   $021,$023,$025,$027,$029,$02c,$02e,$031,$034,$037,$03a,$03e
	 dc.w   $041,$045,$049,$04e,$052,$057,$05c,$062,$068,$06e,$075,$07b
	 dc.w   $083,$08b,$093,$09c,$0a5,$0af,$0b9,$0c4,$0d0,$0dc,$0e9,$0f7
	 dc.w   $106,$115,$126,$137,$14a,$15d,$172,$188,$19f,$1b8,$1d2,$1ee
	 dc.w   $20b,$22a,$24b,$26e,$293,$2ba,$2e4,$310,$33f,$370,$3a4,$3dc
	 dc.w   $417,$455,$497,$4dd,$527,$575,$5c8,$620,$67d,$6e0,$749,$7b8
	 dc.w   $82d,$8a9,$92d,$9b9,$a4d,$aea,$b90,$c40,$cfa,$dc0,$e91,$f6f	
	 EVEN
	
duree1	dc.b	$0
	EVEN
duree2	dc.b	$0
	EVEN
tps1	dc.w	$0
	EVEN
tps2	dc.w	$0
	EVEN
	
unittps	dc.w	$0
	EVEN
	
calc	dc.b	0
	EVEN
	end